/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ASSUNTO                                                  */
/* Tabela : ASSUNTO                                                           */
/*                                                                            */
/* Criao:                                                                   */
/* 17/06/2003 Giane                                                           */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_ASSUNTO
BEFORE INSERT OR UPDATE OR DELETE
ON ASSUNTO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUTASS := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDASSUNTO,0) <> NVL(:NEW.CDASSUNTO,0)) OR
         (NVL(:OLD.NMASSUNTO,0) <> NVL(:NEW.NMASSUNTO,0)) THEN
         :NEW.DTULTATUTASS := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('ASSUNTO', '', 'CDASSUNTO='||:OLD.CDASSUNTO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE ASSUNTO MODIFY DTULTATUTASS DEFAULT SYSDATE
/
