CREATE OR REPLACE
PROCEDURE CUSTO_MEDIO_CTBL
  (P_CDFILIAL   IN FILIAL.CDFILIAL%TYPE, /* FILIAL DE MOVIMENTACAO */
   P_DTREFEMES  IN DATE, /* PRIMEIRO DIA DO PARAMETRO */
   P_CDPRODINI  IN VARCHAR, /* PRODUTO INICIAL */
   P_CDPRODFIN  IN VARCHAR) /* PRODUTO FINAL */
IS
   V_CDSEQUENCIAL VARCHAR2(50);
   V_DTCOMPCTBL DATE;
   V_QTSALDOINI NUMBER; -- QUANTIDADE INICIAL DO PRODUTO
   V_VRSALDOINI NUMBER; -- VALOR INICIAL DO PRODUTO NO ESTOQUE
   V_VRINITEMP NUMBER;
   V_DTMENORENTR DATE; -- DATA DA PRIMEIRA ENTRADA NO PERIODO
   V_VRENTRCALCULO NUMBER; -- VALOR DAS ENTRADAS QUE COMPOEM O CALCULO DO CUSTO MEDIO
   V_QTENTRCALCULO NUMBER; -- QUANTIDADE DAS ENTRADAS QUE COMPOEM O CALCULO DO CUSTO MEDIO
   V_VRSOMAENTRCALCULO NUMBER; -- VALOR DO SOMATRIO DOS VALORES DE ENTRADA QUE COMPEM O CLCULO
   V_QTTOTALENTRADA NUMBER;
   V_VRTOTALENTRADA NUMBER;
   V_VRTOTALSAIDA NUMBER;
   V_QTTOTALSAIDA NUMBER;
   V_QTDEVOLUCAO NUMBER;
   V_VRDEVOLUCAO NUMBER;
   V_QTCALCULOAUX NUMBER;
   V_VRCALCULOAUX NUMBER;
   V_VRCUSTOMEDIO NUMBER;
   V_QTSALDOFIN NUMBER;
   V_VRSALDOFIN NUMBER;
   V_VRTOTALENTR NUMBER;
   V_COUNT NUMBER;
   V_NRNOTAFISC VARCHAR2(20);
   V_VRLANCAMENTO NUMBER;
   V_VRSOMALANC NUMBER;
   V_VRTEMP NUMBER;
   V_IDENTRSAIDOP VARCHAR2(01);
   V_DATABLOQ DATE;
   V_QUANTIMPL NUMBER;
   V_QTAJUSTE NUMBER;

   V_QUANTFINAL NUMBER;
   V_VALORFINAL NUMBER;
   V_QTTEMPIMP NUMBER;
   V_VRTEMPIMP NUMBER;

   V_DATAIMPL DATE;
   V_COUNTATUALIZA NUMBER;

   V_QTAJIMPLLANC NUMBER; /* VARIAVEIS USADAS PARA MOSTRAR OS VALORES (DIFERENCA) QUE FORAM AJUSTADOS NO ESTOQUE */
   V_VRAJIMPLLANC NUMBER;
   V_DARCOMMIT NUMBER;
   V_COMMIT NUMBER;

   V_COUNTAJUSTE NUMBER;
   V_COUNTIMPL NUMBER;
   V_COUNTSAIDMANU NUMBER;

   V_IMPULTDIA VARCHAR2(01); /* IMPLANTACAO ULTIMO DIA */
   V_AJUULTDIA VARCHAR2(01);

   V_DATASOMAAJUIMP DATE;
   V_DATAAJUSTE DATE;

   V_IDENTRMANUFAZPARTE VARCHAR2(01);
   V_IDENTRMANUCALCULO VARCHAR2(01);
   V_IDENTRMANUCUSTOMED VARCHAR2(01);

   V_IDVRCUSTMED VARCHAR2(01);
   PROCEDURE PARAMETRIZACOES_ESTOQUE
   AS
   BEGIN
      V_IMPULTDIA := 'N';
      BEGIN
         SELECT 'S'
           INTO V_IMPULTDIA
           FROM PARAMFILIAL
          WHERE CDFILIAL = P_CDFILIAL
            AND IDORDIMPLANT = 'U';
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_IMPULTDIA := 'N';
      END;

      V_AJUULTDIA := 'N';
      BEGIN
         SELECT 'S'
           INTO V_AJUULTDIA
           FROM PARAMFILIAL
          WHERE CDFILIAL = P_CDFILIAL
            AND IDORDAJUINVE = 'U';
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_AJUULTDIA := 'N';
      END;


      /* IMPLANTACAO VAI PARA MOVIMENTACAO */
      V_COUNTIMPL := 0;
      BEGIN
         SELECT COUNT(*)
           INTO V_COUNTIMPL
           FROM PARAMESTCUSTMED
          WHERE CDFILIAL = P_CDFILIAL
            AND IDIMPLANT = 'S';
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_COUNTIMPL := 0;
      END;

      /* AJUSTE VAI PARA MOVIMENTACAO */
      V_COUNTAJUSTE := 0;
      BEGIN
         SELECT COUNT(*)
           INTO V_COUNTAJUSTE
           FROM PARAMESTCUSTMED
          WHERE CDFILIAL = P_CDFILIAL
            AND IDAJUSTE = 'S';
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_COUNTAJUSTE := 0;
      END;

      /* SAIDAS MANUAIS */
      V_COUNTSAIDMANU := 0;
      BEGIN
         SELECT COUNT(*)
           INTO V_COUNTSAIDMANU
           FROM PARAMESTCUSTMED
          WHERE CDFILIAL = P_CDFILIAL
            AND IDSAIDMANU = 'S';
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_COUNTSAIDMANU := 0;
      END;

      /* VERIFICA SE A ENTRADA MANUAL IR PARA O RELATRIO */
      V_IDENTRMANUFAZPARTE := 'N';
      BEGIN
         SELECT IDENTRMANU
           INTO V_IDENTRMANUFAZPARTE
           FROM PARAMESTCUSTMED
          WHERE IDENTRMANU = 'S'
            AND CDFILIAL = P_CDFILIAL;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_IDENTRMANUFAZPARTE := 'N';
      END;

      /* VERIFICA SE A ENTRADA MANUAL FAR PARTE DO CLCULO */
      V_IDENTRMANUCALCULO := 'N';
      BEGIN
         SELECT IDENTRMANUCALC
           INTO V_IDENTRMANUCALCULO
           FROM PARAMESTCUSTMED
          WHERE IDENTRMANUCALC = 'S'
            AND CDFILIAL = P_CDFILIAL;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_IDENTRMANUCALCULO := 'N';
      END;

      /* VERIFICA SE A ENTRADA MANUAL SER PRECIFICADA PELO CUSTO MDIO */
      V_IDENTRMANUCUSTOMED := 'N';
      BEGIN
         SELECT IDVRCUSTOMEDIO
           INTO V_IDENTRMANUCUSTOMED
           FROM PARAMESTCUSTMED
          WHERE IDVRCUSTOMEDIO = 'S'
            AND CDFILIAL = P_CDFILIAL;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_IDENTRMANUCUSTOMED := 'N';
      END;
   END;

   PROCEDURE CALCULO_DO_CUSTO(P_CDARVPROD IN VARCHAR)
   AS
   BEGIN
      /************* INCIO DO CLCULO DO VALOR DO CUSTO MDIO *****************
         O CUSTO MDIO SEMPRE SEGUE A SEGUINTE REGRA:
         VALOR / QUANTIDADE = CUSTO MDIO,
         SENDO:
             VALOR = VALOR INICIAL MAIS ENTRADAS QUE COMPEM O CLCULO
             QUANTIDADE = QUANTIDADE INICIAL MAIS ENTRADAS QUE COMPEM O CLCULO.
      ***************************************************************************/

      /* REALIZA O SOMATRIO DA QUANTIDADE DE ENTRADA, INDEPENDENTE SE FAZ PARTE
         DO CLCULO OU NO, BASTANDO APENAS ESTAR PARAMETRIZADO PARA IR PARA O RELATRIO */
      BEGIN
         SELECT NVL(SUM(QTLANCMOVIEST), 0), NVL(SUM(QTLANCMOVIEST * VRLANCMOVIEST), 0)
           INTO V_QTTOTALENTRADA, V_VRTOTALENTRADA
           FROM (SELECT L.CDFILIMOVI CDFILIAL, QTLANCMOVIEST, VRLANCMOVIEST,
                        NVL(NF.IDSISTEMA, 'EST') IDSISTEMA
                   FROM RELAT_MOVIEST R JOIN LANCTOESTOQ L LEFT JOIN TIPOOPERCUSTMED T
                                                                  ON T.IDENTRSAIDOP = L.IDENTRSAIDOP
                                                                 AND T.IDENTRSAIDOP = 'E'
                                                                 AND T.IDOPERDEVOL = 'N'
                                                                 AND T.CDFILIAL = L.CDFILIMOVI
                                                                 AND T.CDTIPOOPER = L.CDTIPOOPER
                                                           LEFT JOIN NOTAFISCAL NF
                                                                  ON NF.CDFILIAL = L.CDFILIAL
                                                                 AND NF.NRLANCTONF = L.NRLANCTONF
                                          ON R.CDFILLANCMEST = L.CDFILIAL
                                         AND R.NRLANCMOVIEST = L.NRLANCESTQ
                  WHERE R.CDPRODMOVIEST = P_CDARVPROD
                    AND NRRELATMOVI = V_CDSEQUENCIAL
                    AND R.IDTIPOMOVIEST = '2') MOVENTRADA LEFT JOIN PARAMESTCUSTMED P
                                                                 ON P.CDFILIAL = MOVENTRADA.CDFILIAL
          WHERE (IDSISTEMA <> 'EST')
             OR ((IDSISTEMA = 'EST') AND (V_IDENTRMANUFAZPARTE = 'S'));
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_QTTOTALENTRADA := 0;
            V_VRTOTALENTRADA := 0;
      END;

      /* QUANTIDADE DE DEVOLUES */
      BEGIN
         SELECT NVL(SUM(QTLANCMOVIEST), 0)
           INTO V_QTDEVOLUCAO
           FROM RELAT_MOVIEST R, LANCTOESTOQ L, TIPOOPERCUSTMED T
          WHERE R.CDPRODMOVIEST = P_CDARVPROD
            AND NRRELATMOVI = V_CDSEQUENCIAL
            AND T.IDOPERDEVOL = 'S'
            AND T.IDPARTECALC = 'S'
            AND R.IDTIPOMOVIEST <> '-'
            AND T.CDFILIAL = R.CDFILIMOVIEST
            AND R.CDFILLANCMEST = L.CDFILIAL
            AND R.NRLANCMOVIEST = L.NRLANCESTQ
            AND T.IDENTRSAIDOP = L.IDENTRSAIDOP
            AND T.CDFILIAL = L.CDFILIMOVI
            AND T.CDTIPOOPER = L.CDTIPOOPER;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_QTDEVOLUCAO := 0;
      END;

      /* SOMA A QUANTIDADE DE ENTRADAS E OS VALORES DOS TIPOS DE OPERACAO
         QUE IRO COMPOR O CLCULO DO CUSTO MDIO, TANTO DE NOTAS FISCAIS (COM TIPO DE OPERACAO)
         OU DE LANAMENTOS MANUAIS DO ESTOQUE. */
      BEGIN
         SELECT NVL(SUM(VRLANCMOVIEST * QTLANCMOVIEST), 0), NVL(SUM(QTLANCMOVIEST), 0)
           INTO V_VRENTRCALCULO, V_QTENTRCALCULO
           FROM (SELECT L.CDFILIMOVI CDFILIAL, QTLANCMOVIEST, VRLANCMOVIEST,
                        NVL(NF.IDSISTEMA, 'EST') IDSISTEMA, NVL(T.IDPARTECALC, 'N') IDPARTECALC
                   FROM RELAT_MOVIEST R JOIN LANCTOESTOQ L LEFT JOIN TIPOOPERCUSTMED T
                                                                  ON T.IDENTRSAIDOP = L.IDENTRSAIDOP
                                                                 AND T.CDFILIAL = L.CDFILIMOVI
                                                                 AND T.CDTIPOOPER = L.CDTIPOOPER
                                                                 AND T.IDENTRSAIDOP = 'E'
                                                                 AND T.IDOPERDEVOL = 'N'
                                                                 AND T.IDPARTECALC = 'S'
                                                         LEFT JOIN NOTAFISCAL NF
                                                                ON NF.CDFILIAL = L.CDFILIAL
                                                               AND NF.NRLANCTONF = L.NRLANCTONF
                                          ON R.CDFILLANCMEST = L.CDFILIAL
                                         AND R.NRLANCMOVIEST = L.NRLANCESTQ
                  WHERE R.CDPRODMOVIEST = P_CDARVPROD
                    AND NRRELATMOVI = V_CDSEQUENCIAL
                    AND R.IDTIPOMOVIEST = '2') MOVENTRADA LEFT JOIN PARAMESTCUSTMED P
                                                                 ON P.CDFILIAL = MOVENTRADA.CDFILIAL
          WHERE ((IDSISTEMA <> 'EST') AND (IDPARTECALC = 'S'))
             OR ((IDSISTEMA = 'EST') AND (V_IDENTRMANUFAZPARTE = 'S') AND (V_IDENTRMANUCALCULO = 'S'));
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_VRENTRCALCULO := 0;
            V_QTENTRCALCULO := 0;
      END;

      /* POSSUI ENTRADAS QUE GERAM O VALOR DO CUSTO MEDIO */
      IF V_QTENTRCALCULO <> 0 THEN
         IF V_QTDEVOLUCAO <> 0 THEN
            V_VRDEVOLUCAO := V_QTDEVOLUCAO * ((V_VRSALDOINI + V_VRENTRCALCULO)/(V_QTSALDOINI + V_QTENTRCALCULO));
         ELSE
            V_VRDEVOLUCAO := 0;
         END IF;
      ELSE
         /* NO EXISTE ENTRADA QUE GERA O VALOR DO CUSTO MEDIO */
         IF V_QTDEVOLUCAO <> 0 THEN
            IF (V_QTSALDOINI + V_QTTOTALENTRADA = 0) THEN
               V_VRDEVOLUCAO := V_QTDEVOLUCAO * ((V_VRSALDOINI + V_VRTOTALENTRADA)/1);
            ELSE
               V_VRDEVOLUCAO := V_QTDEVOLUCAO * ((V_VRSALDOINI + V_VRTOTALENTRADA)/(V_QTSALDOINI + V_QTTOTALENTRADA));
            END IF;
         ELSE
            V_VRDEVOLUCAO := 0;
         END IF;
      END IF;

      /* SE EXISTIREM ENTRADAS PELOS TIPOS DE OPERACAO QUE FAZEM PARTE DO CLCULO DO CUSTO MDIO A QUANTIDADE
         (A SER USADA COMO AUXILIAR NO CLCULO) SER CALCULADA UTILIZANDO-AS */
      IF V_QTENTRCALCULO <> 0 THEN
         V_QTCALCULOAUX := V_QTSALDOINI + V_QTENTRCALCULO - V_QTDEVOLUCAO;
         V_VRCALCULOAUX := V_VRSALDOINI + V_VRENTRCALCULO - V_VRDEVOLUCAO;
      ELSE
         /* SENO PEGAR TODAS ENTRADAS */
         V_QTCALCULOAUX := V_QTSALDOINI + V_QTTOTALENTRADA - V_QTDEVOLUCAO;
         V_VRCALCULOAUX := V_VRSALDOINI + V_VRTOTALENTRADA - V_VRDEVOLUCAO;
      END IF;

      /* SE O PRODUTO POSSUI QUANTIDADE INICIAL OU ENTRADAS*/
      IF V_QTCALCULOAUX <> 0 THEN
         IF V_QTENTRCALCULO <> 0 THEN
            /* SE EXISTIR ENTRADA PELAS OPERACOES QUE COMPOEM O CUSTO */
            V_VRCUSTOMEDIO := V_VRCALCULOAUX / V_QTCALCULOAUX;
         ELSE
            /* SE O VALOR INICIAL  DIFERENTE DE 0, O CUSTO  CALCULADO SOMENTE EM CIMA DELE */
            V_QTCALCULOAUX := V_QTSALDOINI - V_QTDEVOLUCAO;
            IF V_QTCALCULOAUX <> 0 THEN
               V_VRCALCULOAUX := V_VRSALDOINI - V_VRDEVOLUCAO;
               V_VRCUSTOMEDIO := V_VRCALCULOAUX / V_QTCALCULOAUX;
            ELSE
                V_VRCUSTOMEDIO := V_VRTOTALENTRADA / V_QTTOTALENTRADA;
            END IF;
         END IF;
      ELSE
         V_VRCALCULOAUX := V_VRSALDOINI - V_VRDEVOLUCAO;

         /* SE O PRODUTO NO POSSUI QUANTIDADE INICIAL E NEM ENTRADAS */
         IF V_VRCALCULOAUX = 0 THEN
            /* SE O SOMATRIO DAS ENTRADAS  DIFERENTE DE 0 */
            IF V_VRTOTALENTRADA <> 0 THEN
               V_VRCUSTOMEDIO := ROUND(V_VRTOTALENTRADA,4)/ROUND(V_QTTOTALENTRADA,4);

            ELSE
               /* SENAO PEGA O LTIMO CUSTO MDIO */
               BEGIN
                  SELECT NVL(VRCUSTOCTBL, 0)
                   INTO V_VRCUSTOMEDIO
                   FROM CUSTMEDCTBL C, PRODUTO P
                  WHERE CDFILIAL = P_CDFILIAL
                    AND C.CDPRODUTO = P.CDPRODUTO
                    AND P.CDARVPROD = P_CDARVPROD
                    AND DTCOMPCTBL = (SELECT MAX(DTCOMPCTBL)
                                        FROM CUSTMEDCTBL CC, PRODUTO PP
                                       WHERE CDFILIAL = P_CDFILIAL
                                         AND DTCOMPCTBL < P_DTREFEMES
                                         AND CC.CDPRODUTO = PP.CDPRODUTO
                                         AND PP.CDARVPROD = P_CDARVPROD
                                         AND VRCUSTOCTBL <> 0);
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_VRCUSTOMEDIO := 0;
               END;
            END IF;
         ELSE
            IF V_QTTOTALENTRADA <> 0 THEN
               V_VRCUSTOMEDIO := ROUND(V_VRCALCULOAUX,4)/ROUND(V_QTTOTALENTRADA,4);
               
               IF V_VRCUSTOMEDIO < 0 THEN
                  V_VRCUSTOMEDIO := ABS(V_VRCUSTOMEDIO);
               END IF;
            ELSE
               BEGIN
                  SELECT NVL(VRCUSTOCTBL, 0)
                   INTO V_VRCUSTOMEDIO
                   FROM CUSTMEDCTBL C, PRODUTO P
                  WHERE CDFILIAL = P_CDFILIAL
                    AND C.CDPRODUTO = P.CDPRODUTO
                    AND P.CDARVPROD = P_CDARVPROD
                    AND DTCOMPCTBL = (SELECT MAX(DTCOMPCTBL)
                                        FROM CUSTMEDCTBL CC, PRODUTO PP
                                       WHERE CDFILIAL = P_CDFILIAL
                                         AND DTCOMPCTBL < P_DTREFEMES
                                         AND CC.CDPRODUTO = PP.CDPRODUTO
                                         AND PP.CDARVPROD = P_CDARVPROD
                                         AND VRCUSTOCTBL <> 0);
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_VRCUSTOMEDIO := 0;
               END;
            END IF;
         END IF;
      END IF;
   END;

   FUNCTION BUSCA_PARAM_EST(P_IDTIPOMOVI IN VARCHAR) RETURN VARCHAR
   AS
   BEGIN
      IF P_IDTIPOMOVI IN ('3', '4') THEN
         RETURN 'S';
      ELSE
         IF P_IDTIPOMOVI = '2' THEN
            RETURN V_IDENTRMANUCUSTOMED;
         ELSE
            RETURN 'S';
         END IF;
      END IF;
   END;
BEGIN
   V_DARCOMMIT := 350;
   V_COMMIT := 0;
   V_COUNT := 0;

   BEGIN
      SELECT COUNT(*), DTBLOQUEIO
        INTO V_COUNT, V_DATABLOQ
        FROM CONTESTCUSTMED
       WHERE DTBLOQUEIO IS NOT NULL
         AND CDFILIAL = P_CDFILIAL
         AND DTBLOQUEIO > P_DTREFEMES
       GROUP BY DTBLOQUEIO;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_COUNT := 0;
   END;
   IF V_COUNT <> 0 THEN
      RAISE_APPLICATION_ERROR(-20501, 'CLCULO BLOQUEADO! PERODO FORA DA DATA DE CONTROLE ('||V_DATABLOQ||') DO CUSTO MDIO!'||
                                      ' FAVOR PROCURAR A CONTABILIDADE.', TRUE);
   END IF;
   NOVO_CODIGO('MOVIESTOQUE', V_CDSEQUENCIAL,1);
   V_CDSEQUENCIAL := SUBSTR(V_CDSEQUENCIAL,11,10);

   MOVIMENTACAO_ESTOQUE (P_CDFILIAL, NULL, NULL, NULL, 10, P_DTREFEMES, LAST_DAY(P_DTREFEMES), P_CDPRODINI, P_CDPRODFIN, '3', '1', V_CDSEQUENCIAL, 'S');

   /* DELETA A TABELA DE LANAMENTOS DETALHADOS */
   DELETE FROM DESCLANCCMCTBL
    WHERE CDFILIAL = P_CDFILIAL
      AND DTCOMPCTBL BETWEEN P_DTREFEMES AND LAST_DAY(P_DTREFEMES)
      AND EXISTS (SELECT 1
                    FROM PRODUTO P
                   WHERE P.CDARVPROD BETWEEN P_CDPRODINI AND P_CDPRODFIN
                     AND P.CDPRODUTO = DESCLANCCMCTBL.CDPRODUTO);

   /* DELETA A TABELA TOTALIZADORA */
   DELETE FROM CUSTMEDCTBL
    WHERE CDFILIAL = P_CDFILIAL
      AND DTCOMPCTBL = P_DTREFEMES
      AND EXISTS (SELECT 1
                    FROM PRODUTO P
                   WHERE P.CDARVPROD BETWEEN P_CDPRODINI AND P_CDPRODFIN
                     AND P.CDPRODUTO = CUSTMEDCTBL.CDPRODUTO);

   /* BUSCA A LTIMA DATA QUE FOI REALIZADO O CLCULO DO CUSTO MDIO
      A VARIVEL V_DTCOMPCTBL CONTM O DIA 01 DO MS. EX: 01/10/2015 */
   BEGIN
      SELECT MAX(DTCOMPCTBL)
        INTO V_DTCOMPCTBL
        FROM CUSTMEDCTBL
       WHERE CDFILIAL = P_CDFILIAL
         AND DTCOMPCTBL < P_DTREFEMES;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_DTCOMPCTBL := NULL;
   END;

   /* PEGA TODOS PRODUTOS QUE TIVERAM MOVIMENTAO. A TABELA RELAT_TOTAMOVI
       UMA TABELA TEMPORRIA, ALIMENTADA PELA PROCEDURE MOVIMENTACAO_ESTOQUE */
   FOR C_PROD IN (SELECT DISTINCT P.CDPRODUTO, P.CDARVPROD
                    FROM RELAT_TOTAMOVI PR, RELAT_MOVIEST R, PRODUTO P
                   WHERE PR.NRRELATTOTA = V_CDSEQUENCIAL
                     AND PR.CDPRODTOTAMOVI = R.CDTOTMOVIEST
                     AND P.CDARVPROD = R.CDPRODMOVIEST
                     AND PR.IDTIPOTOTAMOVI = 'P') LOOP

      /* SE A VARIVEL V_DTCOMPCTBL EST NULA,  PORQUE  A PRIMEIRA VEZ QUE RODA O
         CLCULO DO CUSTO MDIO PARA A FILIAL */
      IF V_DTCOMPCTBL IS NULL THEN
         /* SENDO ASSIM,  PEGO A QUANTIDADE INICIAL DO PRODUTO JUNTO COM SEU VALOR INICIAL
            (REFERENTE AO PERIODO DE EXECUO DA ROTINA) */
         BEGIN
            SELECT NVL(SUM(VRQTDEPINIME),0), NVL(SUM(VRSOMPINI),0)
              INTO V_QTSALDOINI, V_VRSALDOINI
              FROM RELAT_TOTAMOVI R
             WHERE R.CDPRODTOTAMOVI = C_PROD.CDARVPROD
               AND NRRELATTOTA = V_CDSEQUENCIAL
               AND IDTIPOTOTAMOVI = 'P';
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_QTSALDOINI := 0;
               V_VRSALDOINI := 0;
         END;

         /* BUSCA A DATA DA PRIMEIRA ENTRADA NO PERIODO PARA O PRODUTO */
         BEGIN
            SELECT MIN(DTLANCMOVIEST)
              INTO V_DTMENORENTR
              FROM RELAT_MOVIEST
             WHERE NRRELATMOVI = V_CDSEQUENCIAL
               AND CDPRODMOVIEST = C_PROD.CDARVPROD
               AND IDTIPOMOVIEST = '2';
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_DTMENORENTR := NULL;
         END;
         /* CASO TENHA TIDO ALGUMA ENTRADA,  BUSCADO O VALOR DA MOVIMENTAO DA ENTRADA
            PARA QUELA DATA */
         IF V_DTMENORENTR IS NOT NULL THEN
            BEGIN
               SELECT NVL(MAX(VRLANCMOVIEST),0)
                 INTO V_VRINITEMP
                 FROM RELAT_MOVIEST
                WHERE NRRELATMOVI = V_CDSEQUENCIAL
                  AND CDPRODMOVIEST = C_PROD.CDARVPROD
                  AND DTLANCMOVIEST = V_DTMENORENTR
                  AND IDTIPOMOVIEST = '2';
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_VRINITEMP := 0;
            END;
            IF V_VRINITEMP IS NOT NULL THEN
               V_VRSALDOINI := V_VRINITEMP * V_QTSALDOINI;
            END IF;
         END IF;
      ELSE
          /* CASO TENHA UMA DATA, A QUANTIDADE INICIAL E O VALOR INICIAL SO
             PEGOS DE ACORDO COM OS VALORES FINAIS DO MS ENCONTRADO */
         BEGIN
            SELECT NVL(SUM(QTSALDOFIN),0), NVL(SUM(VRSALDOFIN),0)
              INTO V_QTSALDOINI, V_VRSALDOINI
              FROM CUSTMEDCTBL
             WHERE CDFILIAL = P_CDFILIAL
               AND DTCOMPCTBL = V_DTCOMPCTBL
               AND CDPRODUTO = C_PROD.CDPRODUTO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_QTSALDOINI := 0;
               V_VRSALDOINI := 0;
         END;
      END IF;

      /* INSERE VALORES PARA AS VARIAVEIS:
      - V_COUNTAJUSTE
      - V_COUNTIMPL
      - V_COUNTSAIDMANU
      - V_IMPULTDIA
      - V_AJUULTDIA
      - V_IDENTRMANUFAZPARTE
      - V_IDENTRMANUCALCULO
      - V_IDENTRMANUCUSTOMED */
      PARAMETRIZACOES_ESTOQUE;

      /* ROTINA QUE CALCULA O CUSTO MEDIO DO PRODUTO, CONSIDERANDO AS PARAMETRIZACOES POR TIPO DE OPERACAO
         E ROTINAS MANUAIS DE ESTOQUE */
      CALCULO_DO_CUSTO(C_PROD.CDARVPROD);

      /* VARIVEL PARA CONTROLAR COMO SER FEITO O CLCULO DOS VALORES FINAIS E MUDANA
         DO VALOR DO CUSTO MDIO. A VARIVEL TER O VALOR ALTERADO CASO TENHA ALGUM
         AJUSTE OU IMPLANTAO */
      V_DATAIMPL := NULL;
      V_DATASOMAAJUIMP := NULL;
      FOR C_LANCAMENTOS IN
         (SELECT NRLANCMOVIEST, NRSEQUMOVIEST, CDFILLANCMEST, CDTIPOOPERME, ORDEM,
                 IDTIPOMOVIEST, QTLANCMOVIEST, VRLANCMOVIEST,
                 DECODE(IDSISTEMA, 'EST', NULL, T.IDVRCUSTOMEDIO) IDVRCUSTOMEDIO,
                 VRCUSTOIMP, DTLANCMOVIEST, QTLANCAMENTO, NRLANCTONF, IDSISTEMA,
                 CDTIPORETIME
            FROM (SELECT NRLANCMOVIEST, NRSEQUMOVIEST, CDFILLANCMEST,
                         DECODE(NF.IDSISTEMA, NULL, 'XX', L.CDTIPOOPER) CDTIPOOPERME,
                         CDTIPORETIME, NVL(IDORDEMCALC, IDTIPOMOVIEST) ORDEM, IDTIPOMOVIEST,
                         QTLANCMOVIEST, VRLANCMOVIEST,
                         VRCUSTMEDI VRCUSTOIMP, DTLANCMOVIEST,
                         QTLANCAMENTO, L.NRLANCTONF,
                         NVL(NF.IDSISTEMA, 'EST') IDSISTEMA,
                         L.CDFILIMOVI, L.IDENTRSAIDOP
                    FROM RELAT_MOVIEST R JOIN LANCTOESTOQ L LEFT JOIN NOTAFISCAL NF
                                                                   ON NF.CDFILIAL = L.CDFILIAL
                                                                  AND NF.NRLANCTONF = L.NRLANCTONF
                                           ON R.CDFILLANCMEST = L.CDFILIAL
                                          AND R.NRLANCMOVIEST = L.NRLANCESTQ
                   WHERE R.CDPRODMOVIEST = C_PROD.CDARVPROD
                     AND NRRELATMOVI = V_CDSEQUENCIAL
                     AND IDTIPOMOVIEST <> '-') MOV LEFT JOIN TIPOOPERCUSTMED T
                                                          ON T.CDFILIAL = MOV.CDFILIMOVI
                                                         AND T.CDTIPOOPER = MOV.CDTIPOOPERME
                                                         AND T.IDENTRSAIDOP = MOV.IDENTRSAIDOP
          WHERE ((MOV.IDTIPOMOVIEST = '5' AND T.IDOPERDEVOL = 'S') OR
                 (MOV.IDTIPOMOVIEST <> '5' AND T.IDOPERDEVOL = 'N') OR
                 (MOV.IDTIPOMOVIEST = '0') OR
                 (MOV.IDTIPOMOVIEST = '1') OR
                 (MOV.IDTIPOMOVIEST = '2' AND MOV.CDTIPOOPERME = 'XX' AND V_IDENTRMANUFAZPARTE = 'S') OR
                 (MOV.IDTIPOMOVIEST = '3' AND MOV.CDTIPOOPERME = 'XX' AND V_COUNTSAIDMANU <> 0) OR
                 (MOV.IDTIPOMOVIEST = '4' AND MOV.CDTIPOOPERME = 'XX' AND V_COUNTSAIDMANU <> 0))
          ORDER BY DTLANCMOVIEST, ORDEM) LOOP
         IF C_LANCAMENTOS.IDVRCUSTOMEDIO IS NULL THEN
            V_IDVRCUSTMED := BUSCA_PARAM_EST(C_LANCAMENTOS.IDTIPOMOVIEST);
         ELSE
            V_IDVRCUSTMED := C_LANCAMENTOS.IDVRCUSTOMEDIO;
         END IF;

         /* CASO SEJA AJUSTE OU IMPLANTAO, A VARIVEL RECEBER A DATA
            DA MOVIMENTAO */
         IF C_LANCAMENTOS.IDTIPOMOVIEST = '0' THEN
            IF (V_DATAIMPL IS NULL) THEN
               V_DATAIMPL := P_DTREFEMES;
            END IF;
         END IF;
         V_NRNOTAFISC := NULL;
         V_VRLANCAMENTO := V_VRCUSTOMEDIO;
        
         
         /* IDTIPOMOVIEST
          0 - Implantao
          1 - Ajuste
          2 - Entrada
          4 - Sada
          5 - Devoluo
         */
         IF C_LANCAMENTOS.IDTIPOMOVIEST IN ('2', '4', '5') THEN
            V_COUNT := 0;
            /* VERIFICA SE O TIPO DE OPERACAO NO IR SER PRECIFICADO PELO CUSTO MDIO */
            IF V_IDVRCUSTMED = 'N' THEN
               V_COUNT := 1;
            END IF;
            IF V_COUNT <> 0 THEN
               V_VRLANCAMENTO := C_LANCAMENTOS.VRLANCMOVIEST;
               -- RAISE_APPLICATION_ERROR(-20501,V_VRLANCAMENTO,TRUE);
               /* SE TIVER TIDO IMPLANTACAO, A MOVIMENTACAO DEVER PEGAR O VALOR DA IMPLANTACAO */
               IF (V_DATAIMPL IS NOT NULL) THEN
                  V_VRLANCAMENTO := V_VRCUSTOMEDIO;
                   --RAISE_APPLICATION_ERROR(-20501,V_VRLANCAMENTO,TRUE);
               END IF;
            END IF;

            /* CASO SEJA UM LANAMENTO ORIUNDO DE NOTA, O NMERO DA MESMA  BUSCADO */
            IF C_LANCAMENTOS.NRLANCTONF IS NOT NULL THEN
               BEGIN
                 SELECT NRNOTAFISC
                   INTO V_NRNOTAFISC
                   FROM NOTAFISCAL N
                  WHERE N.CDFILIAL = C_LANCAMENTOS.CDFILLANCMEST
                    AND N.NRLANCTONF = C_LANCAMENTOS.NRLANCTONF;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_NRNOTAFISC := NULL;
               END;
            END IF;
         ELSE
            V_NRNOTAFISC := NULL;
         END IF;

         V_COUNT := 0;
         IF C_LANCAMENTOS.IDTIPOMOVIEST = '0' THEN /* Implantao */
            V_COUNT := V_COUNTIMPL;
            IF V_COUNT > 0 THEN
               /* IMPLANTACAO - O VALOR DO CUSTO MDIO DEVE SER ALTERADO.
                  O NOVO VALOR DO CUSTO MDIO, A PARTIR DESSA DATA, SER O VALOR IMPLANTADO.
                  A VARIAVEL V_DATAIMPL SERVE COMO CONTROLE, ELA IDENTIFICA A PARTIR DE QUAL DATA DEVE SER FEITO O CLCULO
                  DA QUANTIDADE E VALOR FINAL DO PRODUTO NO ESTOQUE. OU SEJA, O SOMATORIO DE ENTRADA E SADA DEVER SER FEITO
                  A PARTIR DELA, CONSIDERANDO COMO "SALDO INICIAL" O VALOR IMPLANTADO / AJUSTADO */
               V_IDENTRSAIDOP := 'I';
               V_VRCUSTOMEDIO := C_LANCAMENTOS.VRCUSTOIMP;
               V_VRLANCAMENTO := V_VRCUSTOMEDIO;
               --RAISE_APPLICATION_ERROR(-20501,V_VRLANCAMENTO,TRUE);
               V_DATAIMPL := C_LANCAMENTOS.DTLANCMOVIEST;
               V_DATASOMAAJUIMP := V_DATAIMPL; /* AO SOMAR OS AJUSTES E IMPLANTACOES, OS VALORES DEVEM SER INCLUIDOS */
               IF V_IMPULTDIA = 'S' THEN
                  V_DATASOMAAJUIMP := V_DATASOMAAJUIMP + 1; /* CASO SEJA O LTIMO LANAMENTO DO DIA, A SOMA DEVE SER FEIA A PARTIR DO PRXIMO DIA */
               END IF;
            END IF;
         ELSIF C_LANCAMENTOS.IDTIPOMOVIEST = '1' THEN /* Ajuste */
            V_COUNT := V_COUNTAJUSTE;
            IF V_COUNT <> 0 THEN
               /* PARA OS AJUSTES, OS VALORES DOS LANAMENTOS TERO O VALOR DO CUSTO MDIO */
               V_VRLANCAMENTO := V_VRCUSTOMEDIO;
               V_IDENTRSAIDOP := 'A';
            END IF;
         ELSIF C_LANCAMENTOS.IDTIPOMOVIEST = '2' THEN /* ENTRADA NO ESTOQUE */
            IF C_LANCAMENTOS.IDSISTEMA = 'EST' THEN
               /* LANAMENTO DE ENTRADA FEITO DIRETAMENTE NO ESTOQUE */
               V_COUNT := 1;
            ELSE
               BEGIN
                  SELECT COUNT(*)
                    INTO V_COUNT
                    FROM TIPOOPERCUSTMED
                   WHERE (((CDTIPOOPER = C_LANCAMENTOS.CDTIPOOPERME) AND (IDENTRSAIDOP = 'E'))
                            OR (C_LANCAMENTOS.CDTIPOOPERME = '--'))
                     AND CDFILIAL = P_CDFILIAL;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_COUNT := 0;
               END;
            END IF;
            V_IDENTRSAIDOP := 'E';
         ELSIF C_LANCAMENTOS.IDTIPOMOVIEST = '3' THEN /* RETIRADA DO ESTOQUE */
            V_COUNT := V_COUNTSAIDMANU;
            V_IDENTRSAIDOP := 'S';
         ELSIF C_LANCAMENTOS.IDTIPOMOVIEST = '4' THEN /* SADA DO ESTOQUE */
            IF C_LANCAMENTOS.IDSISTEMA = 'EST' THEN
               V_COUNT := 1;
            ELSE
               BEGIN
                  SELECT COUNT(*)
                    INTO V_COUNT
                    FROM TIPOOPERCUSTMED
                   WHERE (((CDTIPOOPER = C_LANCAMENTOS.CDTIPOOPERME) AND (IDENTRSAIDOP = 'S') AND (IDOPERDEVOL = 'N'))
                          OR (C_LANCAMENTOS.CDTIPOOPERME = '--'))
                     AND CDFILIAL = P_CDFILIAL;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_COUNT := 0;
               END;
            END IF;
            V_IDENTRSAIDOP := 'S';
         ELSIF C_LANCAMENTOS.IDTIPOMOVIEST = '5' THEN /* DEVOLUO */
            BEGIN
               SELECT COUNT(*)
                 INTO V_COUNT
                 FROM TIPOOPERCUSTMED
                WHERE ((CDTIPOOPER = C_LANCAMENTOS.CDTIPOOPERME) AND (IDENTRSAIDOP = 'S') AND (IDOPERDEVOL = 'S'))
                  AND CDFILIAL = P_CDFILIAL;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_COUNT := 0;
            END;
            V_IDENTRSAIDOP := 'S';
         END IF;

        /* CASO SEJA AJUSTE OU IMPLANTAO, A VARIVEL RECEBER A DATA
           DO PERIODO DO CUSTO MEDIO */
         IF C_LANCAMENTOS.IDTIPOMOVIEST IN ('0', '1') THEN
            IF C_LANCAMENTOS.IDTIPOMOVIEST = '0' THEN
               IF (V_DATAIMPL IS NULL) THEN
                  V_DATAIMPL := P_DTREFEMES;
               END IF;
               V_QTAJIMPLLANC := C_LANCAMENTOS.QTLANCMOVIEST;
               V_VRAJIMPLLANC := C_LANCAMENTOS.QTLANCMOVIEST * V_VRCUSTOMEDIO;
            ELSE
               V_QTAJIMPLLANC := C_LANCAMENTOS.QTLANCAMENTO;
               V_VRAJIMPLLANC := C_LANCAMENTOS.QTLANCAMENTO * V_VRCUSTOMEDIO;
            END IF;
         ELSE
            V_QTAJIMPLLANC := 0;
            V_VRAJIMPLLANC := 0;
         END IF;

         IF V_COUNT <> 0 THEN
            INSERT INTO DESCLANCCMCTBL
               (CDFILIAL, CDPRODUTO, DTCOMPCTBL, CDFILILANCCM, NRLANCESTQCM,
                NRSEQUITEMCM, NRNOTAFISCCM, IDTIPOMOVICM,
                CDTIPOOPERCM, CDTIPORETICM, QTAJIMPL, VRAJIMPL,
                QTMOVIMENTOCM, VRMOVIMENTOCM, IDENTRSAIDOP, IDTIPOMOVIEST)
            VALUES
               (P_CDFILIAL, C_PROD.CDPRODUTO, C_LANCAMENTOS.DTLANCMOVIEST, P_CDFILIAL, C_LANCAMENTOS.NRLANCMOVIEST,
                C_LANCAMENTOS.NRSEQUMOVIEST, V_NRNOTAFISC, C_LANCAMENTOS.ORDEM,
                C_LANCAMENTOS.CDTIPOOPERME, C_LANCAMENTOS.CDTIPORETIME, V_QTAJIMPLLANC, V_VRAJIMPLLANC,
                ROUND(C_LANCAMENTOS.QTLANCMOVIEST, 4), ROUND(V_VRLANCAMENTO,4), V_IDENTRSAIDOP, C_LANCAMENTOS.IDTIPOMOVIEST);
            V_COMMIT := V_COMMIT + 1;
            IF V_COMMIT = V_DARCOMMIT THEN
               V_COMMIT := 0;
               COMMIT;
            END IF;
         END IF;
      END LOOP;
      V_VRSALDOFIN := 0;
      V_QTSALDOFIN := 0;

      /* SOMA OS VALORES DE SAIDA PARA MOSTRAR NO RODAP DO RELATRIO */
      BEGIN
         SELECT NVL(SUM(VRMOVIMENTOCM * QTMOVIMENTOCM), 0), NVL(SUM(QTMOVIMENTOCM), 0)
           INTO V_VRTOTALSAIDA, V_QTTOTALSAIDA
           FROM DESCLANCCMCTBL
          WHERE CDFILIAL = P_CDFILIAL
            AND CDPRODUTO = C_PROD.CDPRODUTO
            AND DTCOMPCTBL BETWEEN P_DTREFEMES AND LAST_DAY(P_DTREFEMES)
            AND IDENTRSAIDOP = 'S';
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_VRTOTALSAIDA := 0;
            V_QTTOTALSAIDA := 0;
      END;

      /* SOMA OS VALORES DE AJUSTES QUE RESULTARAM EM SAIDAS DO ESTOQUE */
      BEGIN
         SELECT NVL(SUM(ABS(VRAJIMPL)), 0), NVL(SUM(ABS(QTAJIMPL)), 0)
           INTO V_VRTEMPIMP, V_QTTEMPIMP
           FROM DESCLANCCMCTBL
          WHERE CDFILIAL = P_CDFILIAL
            AND CDPRODUTO = C_PROD.CDPRODUTO
            AND IDENTRSAIDOP = 'A'
            AND DTCOMPCTBL BETWEEN P_DTREFEMES AND LAST_DAY(P_DTREFEMES)
            AND QTAJIMPL < 0;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_VRTEMPIMP := 0;
            V_QTTEMPIMP := 0;
      END;
      V_QTTOTALSAIDA := V_QTTOTALSAIDA + V_QTTEMPIMP;
      V_VRTOTALSAIDA := V_VRTOTALSAIDA + V_VRTEMPIMP;

      /* SOMA OS VALORES QUE ENTRARAM PARA MOSTRAR NO RODAP DO RELATRIO */
      BEGIN
         SELECT NVL(SUM(VRMOVIMENTOCM * QTMOVIMENTOCM), 0), NVL(SUM(QTMOVIMENTOCM), 0)
           INTO V_VRTOTALENTRADA, V_QTTOTALENTRADA
           FROM DESCLANCCMCTBL
          WHERE CDFILIAL = P_CDFILIAL
            AND CDPRODUTO = C_PROD.CDPRODUTO
            AND DTCOMPCTBL BETWEEN P_DTREFEMES AND LAST_DAY(P_DTREFEMES)
            AND IDENTRSAIDOP = 'E';
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_VRTOTALENTRADA := 0;
            V_QTTOTALENTRADA := 0;
      END;

      BEGIN
         SELECT NVL(SUM(VRAJIMPL), 0), NVL(SUM(QTAJIMPL), 0)
           INTO V_VRTEMPIMP, V_QTTEMPIMP
           FROM DESCLANCCMCTBL
          WHERE CDFILIAL = P_CDFILIAL
            AND CDPRODUTO = C_PROD.CDPRODUTO
            AND IDENTRSAIDOP = 'A'
            AND DTCOMPCTBL BETWEEN P_DTREFEMES AND LAST_DAY(P_DTREFEMES)
            AND QTAJIMPL > 0;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_VRTEMPIMP := 0;
            V_QTTEMPIMP := 0;
      END;
      V_QTTOTALENTRADA := V_QTTOTALENTRADA + V_QTTEMPIMP;
      V_VRTOTALENTRADA := V_VRTOTALENTRADA + V_VRTEMPIMP;


      /* CASO NO TENHA TIDO NENHUM AJUSTE OU NENHUMA IMPLANTAO, O CLCULO DOS VALORES FINAIS
         DEVEM  CONSIDERAR TODA MOVIMENTAO, SENDO ASSIM, A VARIVEL V_DATAIMPL ESTAR NULA */
      IF NVL(V_DATAIMPL, P_DTREFEMES) = P_DTREFEMES THEN
         V_VRSALDOFIN := V_VRSALDOINI;
         V_QTSALDOFIN := V_QTSALDOINI;
         /* SOMA OS VALORES DE AJUSTES OU IMPLANTACOES QUE FORAM OS PRIMEIROS LANCAMENTOS DAS MOVIMENTAES,
             POIS A VARIVEL V_DATAIMPL EST NULA OU COM A DATA DO DIA 01 */
         BEGIN
            SELECT NVL(SUM(QTMOVIMENTOCM * VRMOVIMENTOCM), 0), NVL(SUM(QTMOVIMENTOCM), 0)
              INTO V_VRTEMPIMP, V_QTTEMPIMP
              FROM DESCLANCCMCTBL
             WHERE CDFILIAL = P_CDFILIAL
               AND CDPRODUTO = C_PROD.CDPRODUTO
               AND IDENTRSAIDOP = 'I'
               AND DTCOMPCTBL BETWEEN P_DTREFEMES AND LAST_DAY(P_DTREFEMES);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRTEMPIMP := 0;
               V_QTTEMPIMP := 0;
         END;
         IF ((V_QTTEMPIMP <> 0) OR (V_VRTEMPIMP <> 0)) THEN
            V_QTSALDOFIN := 0;
            V_VRSALDOFIN := 0;
         END IF;
         V_QTSALDOFIN := V_QTSALDOFIN + V_QTTEMPIMP;
         V_VRSALDOFIN := V_VRSALDOFIN + V_VRTEMPIMP;

         V_QTSALDOFIN := V_QTSALDOFIN - V_QTTOTALSAIDA;
         V_QTSALDOFIN := V_QTSALDOFIN + V_QTTOTALENTRADA;

         V_VRSALDOFIN := V_VRSALDOFIN - V_VRTOTALSAIDA;
         V_VRSALDOFIN := V_VRSALDOFIN + V_VRTOTALENTRADA;
      ELSE
         V_QUANTFINAL := 0;
         V_VALORFINAL := 0;

         /* SOMA OS VALORES DE IMPLANTACAO */
         BEGIN
            SELECT NVL(SUM(QTMOVIMENTOCM * ABS(VRMOVIMENTOCM)), 0), NVL(SUM(QTMOVIMENTOCM), 0)
              INTO V_VRTEMPIMP, V_QTTEMPIMP
              FROM DESCLANCCMCTBL
             WHERE CDFILIAL = P_CDFILIAL
               AND CDPRODUTO = C_PROD.CDPRODUTO
               AND IDENTRSAIDOP = 'I'
               AND DTCOMPCTBL BETWEEN V_DATAIMPL AND LAST_DAY(P_DTREFEMES);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRTEMPIMP := 0;
               V_QTTEMPIMP := 0;
         END;
         V_QUANTFINAL := V_QUANTFINAL + V_QTTEMPIMP;
         V_VALORFINAL := V_VALORFINAL + V_VRTEMPIMP;

         /* SOMA OS VALORES DE AJUSTES */
         BEGIN
            SELECT NVL(SUM(VRAJIMPL), 0), NVL(SUM(QTAJIMPL), 0)
              INTO V_VRTEMPIMP, V_QTTEMPIMP
              FROM DESCLANCCMCTBL
             WHERE CDFILIAL = P_CDFILIAL
               AND CDPRODUTO = C_PROD.CDPRODUTO
               AND IDENTRSAIDOP = 'A'
               AND DTCOMPCTBL BETWEEN V_DATASOMAAJUIMP AND LAST_DAY(P_DTREFEMES);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRTEMPIMP := 0;
               V_QTTEMPIMP := 0;
         END;
         V_QUANTFINAL := V_QUANTFINAL + V_QTTEMPIMP;
         V_VALORFINAL := V_VALORFINAL + V_VRTEMPIMP;

         /* SOMA OS VALORES DE SAIDA PARA CALCULAR A QUANTIDADE FINAL APOS OS AJUSTES OU IMPLANTACOES DE SALDO */
         BEGIN
            SELECT NVL(SUM(VRMOVIMENTOCM * QTMOVIMENTOCM), 0), NVL(SUM(QTMOVIMENTOCM), 0)
              INTO V_VRTEMPIMP, V_QTTEMPIMP
              FROM DESCLANCCMCTBL
             WHERE CDFILIAL = P_CDFILIAL
               AND CDPRODUTO = C_PROD.CDPRODUTO
               AND IDENTRSAIDOP = 'S'
               AND DTCOMPCTBL BETWEEN V_DATASOMAAJUIMP AND LAST_DAY(P_DTREFEMES);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRTEMPIMP := 0;
               V_QTTEMPIMP := 0;
         END;
          V_QUANTFINAL := V_QUANTFINAL - V_QTTEMPIMP;
          V_VALORFINAL := V_VALORFINAL - V_VRTEMPIMP;

         /* SOMA OS VALORES QUE ENTRARAM NO ESTOQUE APS OS AJUSTES OU IMPLANTACOES */
         BEGIN
            SELECT NVL(SUM(VRMOVIMENTOCM * QTMOVIMENTOCM), 0), NVL(SUM(QTMOVIMENTOCM), 0)
              INTO V_VRTEMPIMP, V_QTTEMPIMP
              FROM DESCLANCCMCTBL
             WHERE CDFILIAL = P_CDFILIAL
               AND CDPRODUTO = C_PROD.CDPRODUTO
               AND IDENTRSAIDOP = 'E'
               AND DTCOMPCTBL BETWEEN V_DATASOMAAJUIMP AND LAST_DAY(P_DTREFEMES);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRTEMPIMP := 0;
               V_QTTEMPIMP := 0;
         END;
         V_QUANTFINAL := V_QUANTFINAL + V_QTTEMPIMP;
         V_VALORFINAL := V_VALORFINAL + V_VRTEMPIMP;
      END IF;

      IF V_DATAIMPL > P_DTREFEMES THEN
         V_QTSALDOFIN := V_QUANTFINAL;
         V_VRSALDOFIN := V_VALORFINAL;
      END IF;

      /* CASO DE UM VALOR NEGATIVO E SEJA MENOR QUE 1 REAL, O VALOR FINAL DEVE SER 0,
         POIS PODE SER QUE DEU DIFERENA NO ARREDONDAMENTO DO CUSTO MDIO */
      IF ((V_QTSALDOFIN = 0) AND (V_VRSALDOFIN < 0)) THEN
         V_VRSALDOFIN := 0;
      END IF;

      /* GRAVA NA TABELA TOTALIZADORA */
      INSERT INTO CUSTMEDCTBL
        (CDFILIAL, CDPRODUTO, DTCOMPCTBL, QTSALDOINI, VRSALDOINI,
         QTTOTALENTRCP, VRTOTALENTRCP, QTTOTALENTR, VRTOTALENTR,
         QTTOTALAUX, VRTOTALAUX, VRCUSTOCTBL, QTTOTALSAID, QTTOTALDEV,
         VRTOTALDEV, QTSALDOFIN, VRSALDOFIN)
      VALUES
         (P_CDFILIAL, C_PROD.CDPRODUTO, P_DTREFEMES, NVL(ROUND(V_QTSALDOINI,4),0), NVL(ROUND(V_VRSALDOINI,4),0),
          0, 0, V_QTTOTALENTRADA, V_VRTOTALENTRADA,
          0, 0, V_VRCUSTOMEDIO, V_QTTOTALSAIDA, V_QTDEVOLUCAO,
          V_VRDEVOLUCAO, V_QTSALDOFIN, V_VRSALDOFIN);
      V_COMMIT := V_COMMIT + 1;
      IF V_COMMIT = V_DARCOMMIT THEN
         V_COMMIT := 0;
         COMMIT;
      END IF;
   END LOOP;
   COMMIT;
END;

/

-- VERSAO --
BEGIN ATUVEROBJ('CUSTO_MEDIO_CTBL','6.10.xxx'); END;
/
