/* TECNISA - TECNOLOGIA EM INFORMTICA

NOME:
REPLICAO DE DOCUMENTOS FISCAIS

DESCRIO:
PROCEDIMENTO PARA GERAO DE DOCUMENTOS FISCAIS

CRIAO:
30/09/99 - ROBERTO A. LOPES MARTINS

@C:\WIN_V4\SQL\END_CONV\ORACLE\5301_FISSTPO.SQL
 raise_application_error(-20501, '' , True);
*/

CREATE OR REPLACE PROCEDURE LOCALESTOQUE_PADRAO
(P_CDFILIAL  IN FILIAL.CDFILIAL%TYPE,
 P_CDPRODUTO IN PRODUTO.CDPRODUTO%TYPE,
 P_CDALMOXARIFE OUT ALMOXARIFADO.CDALMOXARIFE%TYPE,
 P_CDLOCALESTOQ OUT LOCALESTOQUE.CDLOCALESTOQ%TYPE,
 P_IDSISTEMA   IN VARCHAR2 DEFAULT 'DF')
AS

   V_IDUTILALMOX  VARCHAR2(01);
   V_IDUTILLCESTQ VARCHAR2(01);
   V_CDALMOXARIFE ALMOXARIFADO.CDALMOXARIFE%TYPE;
   V_CDLOCALESTOQ LOCALESTOQUE.CDLOCALESTOQ%TYPE;
   V_CDPRODESTO   PRODUTO.CDPRODESTO%TYPE;
   V_COUNT        NUMERIC;

BEGIN

   SELECT NVL(MAX(IDUTILALMOX),'N'), NVL(MAX(IDUTILLCESTQ),'N')
   INTO V_IDUTILALMOX, V_IDUTILLCESTQ
   FROM PARAMFILIAL
   WHERE CDFILIAL = P_CDFILIAL;

   SELECT MAX(CDPRODESTO)
   INTO V_CDPRODESTO
   FROM PRODUTO
   WHERE CDPRODUTO = P_CDPRODUTO;

   IF V_IDUTILALMOX = 'N' THEN
      V_CDALMOXARIFE := ' ';

      SELECT COUNT(*)
      INTO V_COUNT
      FROM ALMOXARIFADO
      WHERE CDFILIAL = P_CDFILIAL;

      IF V_COUNT = 0 THEN
         INSERT INTO ALMOXARIFADO
         (CDFILIAL, CDALMOXARIFE, DSALMOXARIFE)
         VALUES
         (P_CDFILIAL, ' ', ' ');
      END IF;
   ELSE
      IF P_IDSISTEMA = 'EXP' THEN
          SELECT MAX(CDALMOXPRCLI)
          INTO V_CDALMOXARIFE
          FROM PRODFILI
          WHERE CDFILIAL  = P_CDFILIAL AND
                CDPRODUTO = V_CDPRODESTO;
      ELSE
          SELECT MAX(CDALMOXARIFE)
          INTO V_CDALMOXARIFE
          FROM PRODFILI
          WHERE CDFILIAL  = P_CDFILIAL AND
                CDPRODUTO = V_CDPRODESTO;
      END IF;

      IF (V_CDALMOXARIFE IS NULL OR V_CDALMOXARIFE = ' ') THEN
         SELECT MAX(CDALMOXARIFE)
         INTO V_CDALMOXARIFE
         FROM PARAMFILIAL
         WHERE CDFILIAL  = P_CDFILIAL;
      END IF;
   END IF;

   IF V_IDUTILLCESTQ = 'N' THEN
      V_CDLOCALESTOQ := ' ';

      SELECT COUNT(*)
      INTO V_COUNT
      FROM LOCALESTOQUE
      WHERE CDFILIAL     = P_CDFILIAL AND
            CDALMOXARIFE = ' ';

      IF V_COUNT = 0 THEN
         INSERT INTO LOCALESTOQUE
         (CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, DSLOCALESTOQ)
         VALUES
         (P_CDFILIAL, ' ', ' ', ' ');
      END IF;
   ELSE
      IF P_IDSISTEMA = 'EXP' THEN
          SELECT MAX(CDLOCALPRCLI)
          INTO V_CDLOCALESTOQ
          FROM PRODFILI
          WHERE CDFILIAL  = P_CDFILIAL AND
                CDPRODUTO = V_CDPRODESTO;
      ELSE
          SELECT MAX(CDLOCALESTOQ)
          INTO V_CDLOCALESTOQ
          FROM PRODFILI
          WHERE CDFILIAL  = P_CDFILIAL AND
                CDPRODUTO = V_CDPRODESTO;
      END IF;

      IF (V_CDLOCALESTOQ IS NULL OR V_CDLOCALESTOQ = ' ') THEN
         SELECT MAX(CDLOCALESTOQ)
         INTO V_CDLOCALESTOQ
         FROM PARAMFILIAL
         WHERE CDFILIAL  = P_CDFILIAL;
      END IF;
   END IF;

   P_CDALMOXARIFE := V_CDALMOXARIFE;
   P_CDLOCALESTOQ := V_CDLOCALESTOQ;
END;
/

